<script>
import SvgIcon from "@/components/SvgIcon.vue";

export default {
  name: "TempModel",
  components: {
    SvgIcon,
  },
  data() {
    return {
      numbers: [
        "Lo",
        18,
        19,
        20,
        21,
        22,
        23,
        24,
        25,
        26,
        27,
        28,
        29,
        30,
        31,
        "Hi",
      ],
      moveOffset: 300,
      sliderOffset: 0,
      startY: 0,
      currentY: 0,
      currentIndex: 5,
    };
  },
  methods: {
    wrapIndex(index) {
      const length = this.numbers.length;
      return (index + length) % length;
    },
    onTouchStart(event) {
      console.log(event.touches[0].pageY, "开始");
      this.startY = event.touches[0].pageY;
    },
    onTouchMove(event) {
      const touch = event.touches[0];
      const offsetY = touch.pageY - this.startY;
      this.currentY = this.sliderOffset + offsetY;
    },
    onTouchEnd() {
      if (this.currentY > 30 && this.currentIndex > 0) {
        console.log(this.currentIndex, this.moveOffset);
        if (this.currentIndex <= 14 && this.currentIndex != 1) {
          this.moveOffset = this.moveOffset + 120;
        }

        this.currentIndex = this.currentIndex - 1;
      } else if (this.currentY < -30 && this.currentIndex < 15) {
        console.log(this.currentIndex);
        if (this.currentIndex != 0 && this.currentIndex <= 13) {
          this.moveOffset = this.moveOffset - 120;
        }
        this.currentIndex = this.currentIndex + 1;
      }
      this.$emit("getTemperature", this.numbers[this.currentIndex]);
      this.sliderOffset = 0;
      this.currentX = this.sliderOffset;
    },
    clickChange(data) {
      console.log(data);
      if (data == "right" && this.currentIndex > 0) {
        console.log(this.currentIndex, this.moveOffset);
        if (this.currentIndex <= 14 && this.currentIndex != 1) {
          this.moveOffset = this.moveOffset + 120;
        }

        this.currentIndex = this.currentIndex - 1;
      } else if (data == "left" && this.currentIndex < 15) {
        console.log(this.currentIndex);
        if (this.currentIndex != 0 && this.currentIndex <= 13) {
          this.moveOffset = this.moveOffset - 120;
        }
        this.currentIndex = this.currentIndex + 1;
      }
      this.$emit("getTemperature", this.numbers[this.currentIndex]);
      this.sliderOffset = 0;
      this.currentX = this.sliderOffset;
    },
  },
};
</script>

<template>
  <div
    class="temp-model"
    @touchstart="onTouchStart"
    @touchmove="onTouchMove"
    @touchend="onTouchEnd"
  >
    <div class="tag">
      <span>分控</span>
    </div>

    <div class="controller">
      <SvgIcon class="icon1" icon-class="ic_left" />
      <div class="slider-container" ref="sliderContainer">
        <div class="slider-container-hidden">
          <div
            class="slider-wrapper"
            :style="{ transform: `translateX(${$px2vw(moveOffset)})` }"
          >
            <div
              class="number-container"
              v-for="(item, index) in numbers"
              :key="index"
            >
              <span
                class="number"
                :class="currentIndex == index ? 'active' : ''"
              >
                {{ item }}</span
              >
            </div>
            <!-- <div class="number-container">
            <span :class="{ number: true }">{{
              numbers[wrapIndex(currentIndex - 1)]
            }}</span>
          </div>
          <div class="number-container">
            <span :class="{ number: true, active: true }">{{
              numbers[wrapIndex(currentIndex)]
            }}</span>
          </div>
          <div class="number-container">
            <span :class="{ number: true }">{{
              numbers[wrapIndex(currentIndex + 1)]
            }}</span>
          </div> -->
          </div>
        </div>
      </div>
      <SvgIcon class="icon2" icon-class="ic_right" />
    </div>
  </div>
</template>

<style scoped lang="scss">
.temp-model {
  width: 750px;
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  height: 219px;
  padding: 37px 30px;
  border-radius: 9px;
  background: #fff;
  box-sizing: border-box;
  .tag {
    text-align: center;
    background: #2ca1ef;
    color: #fff;
    font-size: 28px;
    border-radius: 24.5px;
    width: 134px;
    height: 49px;
    line-height: 49px;
  }

  .controller {
    margin-top: 30px;
    width: 694px;
    height: 75px;
    border-radius: 32.5px;
    display: flex;
    align-items: center;
    justify-content: center;
    background: linear-gradient(90deg, #00d8fa 0%, #ff6a6a 100%);
    position: relative;
    .icon1 {
      position: absolute;
      width: 12px;
      height: 23px;
      left: 30px;
    }
    .icon2 {
      position: absolute;
      width: 12px;
      height: 23px;
      right: 30px;
    }
  }
}

.slider-container {
  overflow: hidden;
  width: 100%;
  height: 65px;
  margin: 0 auto;
  display: flex;
  justify-content: center;
}
.slider-container-hidden {
  width: 360px;
  overflow: hidden;
  height: 65px;
}
.slider-wrapper {
  height: 100%;
  display: flex;
  justify-content: center;
  transition: transform 0.3s;
  align-items: center;
}

.number-container {
  display: flex;
  justify-content: center;
  align-items: center;
  height: 100%;
  padding: 0 42px;
}

.number {
  display: flex;
  justify-content: center;
  align-items: center;
  font-size: 38px;
  color: #fff;
  transition: transform 0.3s;
}

.active {
  font-size: 38px;
  color: #ffffff;
  transform: scale(2);
}
</style>
